/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package it.unitn.danielezotta;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet per richiesta AJAX get o post per il valore di una cella
 * @author daniele.zotta
 */
@WebServlet(name = "GetCellValue", urlPatterns = {"/GetCellValue"})
public class GetCellValue extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        
        // Parametri per risultato
        int sudokuId = Integer.parseInt(request.getParameter("id"));
        int rowId = Integer.parseInt(request.getParameter("row")) - 1;
        int colId = Integer.parseInt(request.getParameter("col")) - 1;
        
        String url = "jdbc:derby://localhost:1527/ExamDerbyDB";
        String username = "WEBENGINE";
        String password = "WEBENGINE";

        ResultSet results = null;

        // Connessione a DB ed esecuzione query
        try {
            Class.forName("org.apache.derby.jdbc.ClientDriver");
            Connection conn = DriverManager.getConnection(url, username, password);
            String sqlQuery = "SELECT * FROM WEBENGINE.\"DATA\" WHERE ID=" + sudokuId;
            Statement stmt = conn.createStatement();
            results = stmt.executeQuery(sqlQuery);
        } catch (Exception e) {
            e.printStackTrace();
        }
        
        try (PrintWriter out = response.getWriter()) {
            
            String output = "";
            
            // Se connessione a buon fine, invia json con valore corrispondente
            if (results == null) {
                output = "{\"success\" : false, \"value\" : 0}";
            } else {
                try {
                    while(results.next()) {
                        String cells = results.getString(3);
                        output = "{\"success\" : true, \"value\" : " + cells.split(" ")[((rowId*9) + colId)] + "}";
                    }
                } catch (Exception e) {
                    output = "{\"success\" : false, \"value\" : 0}";
                }
            }
            
            out.println(output);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
