/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package it.unitn.danielezotta;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet per richiesta AJAX get o post valori iniziali del sudoku, 
 * restituisce array JSON di oggetti
 * @author daniele.zotta
 */
@WebServlet(name = "GetSudokuStart", urlPatterns = {"/GetSudokuStart"})
public class GetSudokuStart extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        
        int sudokuId = Integer.parseInt(request.getParameter("id"));
        
        String url = "jdbc:derby://localhost:1527/ExamDerbyDB";
        String username = "WEBENGINE";
        String password = "WEBENGINE";

        ResultSet results = null;

        // Connessione al DB
        try {
            Class.forName("org.apache.derby.jdbc.ClientDriver");
            Connection conn = DriverManager.getConnection(url, username, password);
            String sqlQuery = "SELECT * FROM WEBENGINE.\"DATA\" WHERE ID=" + sudokuId;
            Statement stmt = conn.createStatement();
            results = stmt.executeQuery(sqlQuery);
        } catch (Exception e) {
            e.printStackTrace();
        }
        
        StringBuffer b = new StringBuffer();
        
        try (PrintWriter out = response.getWriter()) {
                        
            b.append("[ ");
            
            // Se connessione avvenuta correttamente, allora scrivi oggetti JSON 
            // in array
            if (results != null) {
                try {
                    while(results.next()) {
                        String[] cells = results.getString(2).split(" ");
                        String[] values = results.getString(3).split(" ");
                        for (int i = 0; i < cells.length; i++) {
                            int row = Integer.parseInt(cells[i].split("")[0]);
                            int col = Integer.parseInt(cells[i].split("")[1]);
                            String value = values[(((row-1)*9) + (col-1))];
                            b.append("{\"row\" : " + (row) + ", \"col\" : " + (col) + ", \"value\" : " + value + "}");
                            if (i < (cells.length - 1)) {
                                b.append(", ");
                            }
                        }                     
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }            
            
            b.append(" ]");            
            out.println(b.toString());
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
