<%-- 
    Document   : index
    Created on : Feb 17, 2021, 2:19:40 PM
    Author     : daniele.zotta
--%>

<%@page import="java.sql.Statement"%>
<%@page import="java.sql.ResultSet"%>
<%@page import="java.sql.DriverManager"%>
<%@page import="java.sql.Connection"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%
    // Stringhe di connessione
    String url = "jdbc:derby://localhost:1527/ExamDerbyDB";
    String username = "WEBENGINE";
    String password = "WEBENGINE";
    
    // Risultati null se errore
    ResultSet results = null;
    
    // Connessione al db
    try {
        Class.forName("org.apache.derby.jdbc.ClientDriver");
        Connection conn = DriverManager.getConnection(url, username, password);
        String sqlQuery = "SELECT * FROM WEBENGINE.\"DATA\"";
        Statement stmt = conn.createStatement();
        results = stmt.executeQuery(sqlQuery);
    } catch (Exception e) {
        e.printStackTrace();
    }
%>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Sudoku</title>
        <link rel="stylesheet" href="css/bootstrap.min.4.5.0.css"/>
        <link rel="stylesheet" href="css/style.css"/>
    </head>
    <body>
        <div class="container m-5 mx-auto">
            <h1 class="text-center mt-5">Welcome to Sudoku by Daniele Zotta</h1>
            <div class="text-center mt-5">
                <img class="text-center" width="50%" src="images/sudoku.jpg" alt="Sudoku"/>
            </div>
            <br/>
            <ul>
            <%
                // Stampa dei sudoku nel db
                try {
                    while (results.next()) {
                        %>
                        <li class="m-2">
                            <a href="game.jsp?index=<%= results.getInt(1) %>">Sudoku n. <%= results.getInt(1) %></a>
                        </li>
                        <%
                    }
                } catch (NullPointerException e) {
                    %>
                        <p>Errore di connessione al DB</p>
                    <%
                }
            %>
            </ul>
        </div>        
        
        <script src="js/jquery.min.3.4.1.js"></script>
        <script src="js/bootstrap.min.4.5.0.js"></script>
    </body>
</html>
